glibmm: Gio::UnixSocketAddress Class Reference

glibmm 2.72.0

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::UnixSocketAddress Class Reference
Portable Network I/O Functionality

UnixSocketAddress - UNIX SocketAddress. More...

`#include <giomm/unixsocketaddress.h>`

Inheritance diagram for Gio::UnixSocketAddress:
[legend]

## Public Types
enum class | Type { INVALID , ANONYMOUS , PATH , ABSTRACT , ABSTRACT_PADDED }
| The type of name used by a UnixSocketAddress. More...
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| UnixSocketAddress (UnixSocketAddress && src) noexcept
UnixSocketAddress & | operator= (UnixSocketAddress && src) noexcept
| ~UnixSocketAddress () noexcept override
GUnixSocketAddress * | gobj ()
| Provides access to the underlying C GObject. More...
const GUnixSocketAddress * | gobj () const
| Provides access to the underlying C GObject. More...
GUnixSocketAddress * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Type | get_address_type () const
| Gets address's type. More...
std::string | get_path () const
| Gets address's path, or for abstract sockets the "name". More...
Glib::PropertyProxy_ReadOnly< Type > | property_address_type () const
| The type of UNIX socket address. More...
Glib::PropertyProxy_ReadOnly< std::string > | property_path () const
| UNIX socket path. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Glib::ByteArray > > | property_path_as_array () const
| UNIX socket path, as byte array. More...
Public Member Functions inherited from Gio::SocketAddress
| SocketAddress (SocketAddress && src) noexcept
SocketAddress & | operator= (SocketAddress && src) noexcept
| ~SocketAddress () noexcept override
GSocketAddress * | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketAddress * | gobj () const
| Provides access to the underlying C GObject. More...
GSocketAddress * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
SocketFamily | get_family () const
| Gets the socket family type of address. More...
bool | to_native (gpointer dest, gsize destlen)
| Converts a SocketAddress to a native struct sockaddr, which can be passed to low-level functions like connect() or bind(). More...
gssize | get_native_size () const
| Gets the size of address's native struct sockaddr. More...
Glib::PropertyProxy_ReadOnly< SocketFamily > | property_family () const
| The family of the socket address. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead. More...
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject * | gobj ()
| Provides access to the underlying C GObject. More...
const GObject * | gobj () const
| Provides access to the underlying C GObject. More...
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::SocketConnectable
| SocketConnectable (SocketConnectable && src) noexcept
SocketConnectable & | operator= (SocketConnectable && src) noexcept
| ~SocketConnectable () noexcept override
GSocketConnectable * | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketConnectable * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< SocketAddressEnumerator > | enumerate ()
| Creates a SocketAddressEnumerator for connectable. More...
Glib::RefPtr< const SocketAddressEnumerator > | enumerate () const
| Creates a SocketAddressEnumerator for connectable. More...
Glib::RefPtr< SocketAddressEnumerator > | proxy_enumerate ()
| Creates a SocketAddressEnumerator for connectable that will return a ProxyAddress for each of its addresses that you must connect to via a proxy. More...
Glib::RefPtr< const SocketAddressEnumerator > | proxy_enumerate () const
| Creates a SocketAddressEnumerator for connectable that will return a ProxyAddress for each of its addresses that you must connect to via a proxy. More...
Glib::ustring | to_string () const
| Format a SocketConnectable as a string. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject * castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< UnixSocketAddress > | create (const std::string & path)
| Creates a new UnixSocketAddress for path. More...
static Glib::RefPtr< UnixSocketAddress > | create (const std::string & path, Type type, int path_len=-1)
| Creates a new UnixSocketAddress of type type with name path. More...
static bool | abstract_names_supported ()
| Checks if abstract UNIX domain socket names are supported. More...
Static Public Member Functions inherited from Gio::SocketAddress
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< SocketAddress > | create (gpointer native, gsize len)
| Creates a SocketAddress subclass corresponding to the native struct sockaddr native. More...
Static Public Member Functions inherited from Gio::SocketConnectable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| UnixSocketAddress (const std::string & path)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::SocketConnectable
| SocketConnectable ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixSocketAddress > | wrap (GUnixSocketAddress * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::SocketAddress
Glib::RefPtr< Gio::SocketAddress > | wrap (GSocketAddress * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)
Related Functions inherited from Gio::SocketConnectable
Glib::RefPtr< Gio::SocketConnectable > | wrap (GSocketConnectable * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

UnixSocketAddress - UNIX SocketAddress.

Support for UNIX-domain (also known as local) sockets.

UNIX domain sockets are generally visible in the filesystem. However, some systems support abstract socket names which are not visible in the filesystem and not affected by the filesystem permissions, visibility, etc. Currently this is only supported under Linux. If you attempt to use abstract sockets on other systems, function calls may return Gio::IO_ERROR_NOT_SUPPORTED errors. You can use Gio::UnixSocketAddress::abstract_names_supported() to see if abstract names are supported.

Note that `<giomm/unixsocketaddress.h>` belongs to the UNIX-specific GIO interfaces.

Since glibmm 2.28:

## Constructor & Destructor Documentation

## ◆ UnixSocketAddress() [1/2]

Gio::UnixSocketAddress::UnixSocketAddress | ( | UnixSocketAddress && | src | ) |
| noexcept

## ◆ ~UnixSocketAddress()

Gio::UnixSocketAddress::~UnixSocketAddress | ( |  | ) |
| overridenoexcept

## ◆ UnixSocketAddress() [2/2]

Gio::UnixSocketAddress::UnixSocketAddress | ( | const std::string & | path | ) |
| explicitprotected

## Member Function Documentation

## ◆ abstract_names_supported()

static bool Gio::UnixSocketAddress::abstract_names_supported | ( |  | ) |
| static

Checks if abstract UNIX domain socket names are supported.

Since glibmm 2.22:

Returns
  `true` if supported, `false` otherwise.

## ◆ create() [1/2]

static Glib::RefPtr<UnixSocketAddress> Gio::UnixSocketAddress::create | ( | const std::string & | path | ) |
| static

Creates a new UnixSocketAddress for path.

To create abstract socket addresses, on systems that support that, use g_unix_socket_address_new_abstract().

Since glibmm 2.22:

Parameters

  path | The socket path.

Returns
  A new UnixSocketAddress.

## ◆ create() [2/2]

static Glib::RefPtr<UnixSocketAddress> Gio::UnixSocketAddress::create | ( | const std::string & | path,
|  | Type | type,
|  | int | path_len = `-1`
| ) |  |
| static

Creates a new UnixSocketAddress of type type with name path.

If type is Gio::UnixSocketAddress::Type::PATH, this is equivalent to calling g_unix_socket_address_new().

If type is Gio::UnixSocketAddress::Type::ANONYMOUS, path and path_len will be ignored.

If path_type is Gio::UnixSocketAddress::Type::ABSTRACT, then path_len bytes of path will be copied to the socket's path, and only those bytes will be considered part of the name. (If path_len is -1, then path is assumed to be NUL-terminated.) For example, if path was "test", then calling g_socket_address_get_native_size() on the returned socket would return 7 (2 bytes of overhead, 1 byte for the abstract-socket indicator byte, and 4 bytes for the name "test").

If path_type is Gio::UnixSocketAddress::Type::ABSTRACT_PADDED, then path_len bytes of path will be copied to the socket's path, the rest of the path will be padded with 0 bytes, and the entire zero-padded buffer will be considered the name. (As above, if path_len is -1, then path is assumed to be NUL-terminated.) In this case, g_socket_address_get_native_size() will always return the full size of a `struct sockaddr_un`, although g_unix_socket_address_get_path_len() will still return just the length of path.

Gio::UnixSocketAddress::Type::ABSTRACT is preferred over Gio::UnixSocketAddress::Type::ABSTRACT_PADDED for new programs. Of course, when connecting to a server created by another process, you must use the appropriate type corresponding to how that process created its listening socket.

Since glibmm 2.26:

Parameters

  path | The name.
  path_len | The length of path, or -1.
  type | A Gio::UnixSocketAddress::Type.

Returns
  A new UnixSocketAddress.

## ◆ get_address_type()

Type Gio::UnixSocketAddress::get_address_type | ( |  | ) | const

Gets address's type.

Since glibmm 2.26:

Returns
  A Gio::UnixSocketAddress::Type.

## ◆ get_path()

std::string Gio::UnixSocketAddress::get_path | ( |  | ) | const

Gets address's path, or for abstract sockets the "name".

Guaranteed to be zero-terminated, but an abstract socket may contain embedded zeros, and thus you should use g_unix_socket_address_get_path_len() to get the true length of this string.

Since glibmm 2.22:

Returns
  The path for address.

## ◆ get_type()

static GType Gio::UnixSocketAddress::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GUnixSocketAddress* Gio::UnixSocketAddress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GUnixSocketAddress* Gio::UnixSocketAddress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GUnixSocketAddress* Gio::UnixSocketAddress::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

UnixSocketAddress& Gio::UnixSocketAddress::operator= | ( | UnixSocketAddress && | src | ) |
| noexcept

## ◆ property_address_type()

Glib::PropertyProxy_ReadOnly< Type > Gio::UnixSocketAddress::property_address_type | ( |  | ) | const

The type of UNIX socket address.

Default value: Gio::UnixSocketAddress::Type::PATH

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_path()

Glib::PropertyProxy_ReadOnly< std::string > Gio::UnixSocketAddress::property_path | ( |  | ) | const

UNIX socket path.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_path_as_array()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Glib::ByteArray> > Gio::UnixSocketAddress::property_path_as_array | ( |  | ) | const

UNIX socket path, as byte array.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::UnixSocketAddress > wrap | ( | GUnixSocketAddress * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.